<?php

namespace Ilabs\Omnibus_By_Ilabs;

class Lowest_Price_Cache_Post_Meta_Repository implements Lowest_Price_Cache_Repository_Interface {

	public function update( Price_Model $price, int $product_id ) {
		update_post_meta( $product_id, $this->get_post_meta_key(), $price->to_array() );
	}

	public function get( int $product_id ): ?Price_Model {
		$result = get_post_meta( $product_id, $this->get_post_meta_key(), true );

		if (!is_array($result)){
			return null;
		}

		$result = (new Price_Model_Factory())->create($result);

		if ( ! $result instanceof Price_Model ) {
			return null;
		}

		return $result;
	}

	protected function get_post_meta_key(): string {
		return omnibus_by_ilabs()->add_slug_prefix( 'lowest_price_cache' );
	}
}
